# This file was auto-generated by Fern from our API Definition.

import datetime as dt
import typing

import pydantic

from ..core.datetime_utils import serialize_datetime
from .agent import Agent
from .call_machine_detection_result import CallMachineDetectionResult
from .call_status import CallStatus


class Call(pydantic.BaseModel):
    id: str
    user_id: str
    status: typing.Optional[CallStatus]
    error_message: typing.Optional[str]
    recording_available: typing.Optional[bool]
    transcript: typing.Optional[str]
    machine_detection_result: typing.Optional[CallMachineDetectionResult]
    to_number: str
    from_number: str
    agent: Agent
    agent_phone_number: str
    start_time: typing.Optional[dt.datetime]
    end_time: typing.Optional[dt.datetime]
    hipaa_compliant: typing.Optional[bool]

    def json(self, **kwargs: typing.Any) -> str:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().json(**kwargs_with_defaults)

    def dict(self, **kwargs: typing.Any) -> typing.Dict[str, typing.Any]:
        kwargs_with_defaults: typing.Any = {"by_alias": True, "exclude_unset": True, **kwargs}
        return super().dict(**kwargs_with_defaults)

    class Config:
        frozen = True
        smart_union = True
        json_encoders = {dt.datetime: serialize_datetime}
